<template>
  <div class="photo">
    <div class="container">
      <div v-if="!images.length">
        <div class="text-3xl my-14 opacity-80 text-center">
          Лучший способ поднять настроение — вспомнить что-нибудь приятное.
        </div>
        <div class="flex flex-col">
          <div class="flex justify-between items-center flex-wrap sm:flex-nowrap">
            <img class="sm:w-1/2 w-full mb-10 sm:mb-0 mr-4" src="../../assets/images/order/photo_1.jpeg" alt="">
            <div class="sm:w-1/2 w-full px-10">
              Фотографии освежают все воспоминания, ведь мы стараемся
              запечатлеть на снимках именно счастливые моменты нашей жизни.
              Вы можете распечатать фото в регионах России на фотобумаге
              Стандарт в разных форматах: от 10х10 см до 21х30 см.
            </div>
          </div>
          <div class="flex justify-between items-center flex-wrap sm:flex-nowrap">
            <img class="sm:w-1/2 w-full block sm:hidden my-10 sm:my-0" src="../../assets/images/order/photo_2.jpeg" alt="">
            <div class="sm:w-1/2 w-full mr-4 px-10">
              Выбирайте матовые или глянцевые снимки, смотрите их в печатном
              виде почаще и делитесь с друзьями! Загружайте фотоснимки
              на фотопечать в регионах России с разных носителей:
              компьютера, смартфона и даже напрямую через социальные сети.
            </div>
            <img class="sm:w-1/2 w-full hidden sm:block" src="../../assets/images/order/photo_2.jpeg" alt="">
          </div>
        </div>
      </div>
      <div>
        <div v-if="!images.length" class="px-12 sm:px-0">
          <div v-if="!user" class="text-xl mt-14 mb-5 opacity-80 text-center">Для заказа фотографий необходимо войти или зарегистрироваться</div>
          <div v-else class="text-3xl mt-14 mb-5 opacity-80 text-center">Выбрать фотографии</div>
          <div v-if="!user" class="flex w-full sm:w-1/2 mx-auto">
            <label @click="authModal = 'signIn'" class="button w-full mr-2">Авторизация</label>
            <label @click="authModal = 'sign'" class="button w-full">Регистрация</label>
          </div>
          <label v-else for="upload-photo" class="button w-full sm:w-1/3 mx-auto">Нажмите чтобы выбрать</label>
          <input
              @change="selectImages"
              ref="inputImages"
              hidden
              id="upload-photo"
              type="file"
              accept="image/*"
              multiple
          >
        </div>
        <div v-else>
          <div class="text-3xl mt-14 mb-5 opacity-70 text-center">Фото на печать</div>
          <div class="flex mb-5 justify-center">
            <div class="mr-2">Количество: {{images.length}} шт.</div>
            <div>на сумму: {{price}} р</div>
          </div>
          <label for="upload-photo" class="button w-full sm:w-1/2 lg:w-1/3 mx-auto">
            Добавить
            <img src="../../assets/images/icons/plus.png" alt="">
          </label>
          <input
              @change="selectImages"
              ref="inputImages"
              hidden
              id="upload-photo"
              type="file"
              accept="image/*"
              multiple
          >
        </div>
      </div>
    </div>

    <div class="mx-auto mb-10" style="width: 100%">
      <div v-if="images.length" class="opacity-40 text-sm flex items-center">
        <img src="../../assets/images/icons/alert-circle-outline_BLACK.png" class="mr-1" alt="Индивидуальный рамер печати фотографии">
        Если вам нужен не стандартный размер фотографии, во время кадрирования можно выбрать нужный вам размер
      </div>
      <div class="preview-image-wrap">
        <div
            v-for="(img, i) in images"
            :key="'images-upload-'+i"
            class="preview-image-container"
        >
          <div
              class="card h-52 preview-image cursor-zoom-in"
              :style="{
                background: `url(${img.file})`,
                backgroundPosition: 'center',
                backgroundSize: 'cover'
              }"
              @click.prevent="selectOpenImage(i)"
              title="Увеличить"
          >
          </div>
          <span @click.prevent="selectCropImage(img.file, {w: img.w, h: img.h}, i)" class="image-crop" title="Кадрировать"></span>
          <span @click.prevent="deleteImage(i)" class="image-delete" title="Убрать"></span>
          <select @change="selectSize(i, $event)" class="float-right" style="transform: translate(0, -20px)" id="" title="Размер">
            <option>10x15</option>
            <option>15x20</option>
            <option>20x30</option>
            <option v-if="img.notStandardSize" :selected="img.notStandardSize">{{`${img.w}x${img.h}`}}</option>
          </select>
        </div>
      </div>
    </div>
    <div v-if="images.length" class="container">
      <div class="flex flex-end mb-10">
        <div @click="orderImages" class="button sm:mr-10 mx-auto w-1/2 sm:w-48">Заказать
          <img v-if="!loading" class="h-5 ml-2" src="../../assets/images/icons/cart-variant.png" alt="">
          <loads-spinner v-else small/>
        </div>
      </div>
    </div>
    <div id="scroll-to"></div>
    <Modal v-if="openImageModal" @close="openImageModal = false" :is-close="false" :is-confirm="false" no-border>
      <template v-slot:body>
        <img :src="openImage" class="max-h-screen">
      </template>
    </Modal>
    <Modal v-if="orderModal" @close="orderModal = false" :is-close="false" :is-confirm="false">
      <template v-slot:body>
        <div>
          <div class="text-3xl opacity-70 text-white">Ваш заказ принят!</div>
          <div class="my-4">
            <div class="text-3xl text-red-800 opacity-900 p-2 bg-zinc-800 rounded my-5">Номер заказа:  {{numberOrder}}</div>
          </div>
          <div v-if="user" class="text-white text-xl opacity-80">Так же вы можете найти его в <router-link :to="{name: 'Orders'}" class="link">истории заказов</router-link></div>
        </div>
      </template>
    </Modal>
    <Modal v-if="authModal.length" @close="authModal = ''" :is-confirm="false" :is-close="false">
      <template v-slot:body>
        <Auth :sign="authModal === 'sign'" :sign-in="authModal === 'signIn'"/>
      </template>
    </Modal>
    <FullModal v-if="cropImageModal" @close="cropImageModal = false" :is-close="false" no-border>
      <template v-slot:body>
        <Crop :img-src="cropImage.img" :size="{w: cropImage.w, h: cropImage.h}" @cropImage="readyCropImage" @close="closeCropModal"/>
      </template>
    </FullModal>
  </div>
</template>

<script>
import {ref, reactive, watch, computed} from "vue";
import Modal from "../../components/Modal.vue";
import {supabase} from "../../supabase";
import {useStore} from "vuex";
import LoadsSpinner from "../../components/Loads-spinner.vue";
import Auth from "../../components/Auth.vue";
import Crop from "../../components/Crop.vue";
import FullModal from "../../components/FullModal.vue";

export default {
  name: "Photo",
  components: {FullModal, Crop, Auth, LoadsSpinner, Modal},
  setup() {
    const store = useStore()
    let user = computed(function () {
      return store.state.user
    });

    const loading = ref(false)
    const authModal = ref('')
    const images = ref([])
    const notStandardSize = reactive({
      images: [],
      count: 0,
    })
    const cropImage = reactive({
      img: '',
      index: '',
      w: 0,
      h: 0
    })
    const cropImageModal = ref(false)
    const files = ref([])

    //выбор фото из файловой системы
    function selectImages(img) {
      for (let i = 0; i < img.target.files.length; i++) {
        images.value.push(
            {
              file: URL.createObjectURL(img.target.files[i]),
              name: img.target.files[i].name,
              w: 100,
              h: 150,
              notStandardSize: false
            }
        )
        files.value.push(img.target.files[i])
      }
    }

    // Выбор фото для кадрирования
    function selectCropImage(img, size, index) {
      cropImageModal.value = true
      cropImage.img = img
      cropImage.index = index
      cropImage.w = size.w
      cropImage.h = size.h
    }
    // после того как скадрировали получаем img и выполняем действия
    function readyCropImage(img) {
      // если фотки нестандрат. то закинем инфу и саму фотку отдельно чтоб посчитать стоимость
      if (img.notStandardSize) {
        notStandardSize.status = true
        images.value[cropImage.index].w = img.width
        images.value[cropImage.index].h = img.height
        images.value[cropImage.index].notStandardSize = true
        notStandardSize.count++
      }
      files.value[cropImage.index] = img.file
      images.value[cropImage.index].file = URL.createObjectURL(img.file)
      cropImageModal.value = false
    }

    // отмена кадрирования и закрытие окна
    function closeCropModal () {
      cropImageModal.value = false
    }

    function deleteImage(i) {
      images.value.splice(i, 1)
      files.value.splice(i, 1)
    }

    const openImageModal = ref(false)
    const openImage = ref(0)
    function selectOpenImage(i) {
      openImage.value = images.value[i].file
      openImageModal.value = true
    }

    // выбор размера фотки
    const price = ref(0)
    function selectSize(i, el) {
      if (el.target.value === '10x15') {
        cropImage.w = 100
        cropImage.h = 150
        images.value[i].w = 100
        images.value[i].h = 150
        files.value[i].w = 100
        files.value[i].h = 150
      } else if (el.target.value === '15x20') {
        cropImage.w = 150
        cropImage.h = 200
        images.value[i].w = 150
        images.value[i].h = 200
        files.value[i].w = 150
        files.value[i].h = 200
      } else if (el.target.value === '20x30') {
        cropImage.w = 200
        cropImage.h = 300
        images.value[i].w = 200
        images.value[i].h = 300
        files.value[i].w = 200
        files.value[i].h = 300
      }
      calcImages()
    }

    // подсчет стоимости всех фоток
    function calcImages() {
      price.value = 0
      images.value.forEach(el => {
        if (el.w <= 100 && el.h <= 150) return price.value += (20 + (el.notStandardSize && + 30))
        else if (el.w <= 150 && el.h <= 100) return price.value += (20 + (el.notStandardSize && + 30))
        else if (el.w <= 150 && el.h <= 200) return price.value += (40 + (el.notStandardSize && + 30))
        else if (el.w <= 200 && el.h <= 150) return price.value += (40 + (el.notStandardSize && + 30))
        else if (el.w <= 200 && el.h <= 300) return price.value += (100 + (el.notStandardSize && + 30))
        else if (el.w <= 300 && el.h <= 200) return price.value += (100 + (el.notStandardSize && + 30))
      })
    }

    const numberOrder = ref(0) // будущий номер заказа
    const orderModal = ref(false) // окно которое показывыет успешный заказ и его номер
    async function orderImages () {
      try {
        loading.value = true
        if (!files.value || files.value.length === 0) {
          throw new Error("You must select an image to upload.")
        }
        numberOrder.value = Math.floor(Math.random() * (999999 - 1 + 1)) + 1 // рандомное чилсо из 6 цифр для номера заказа
        const updateImages = [] // массив для названий файлов
        files.value.forEach((file, index) => {
          console.log(file)
          const fileExt = images.value[index].name.split(".").pop()
          const fileName = `${Math.random()}.${fileExt}`
          const filePath = `${fileName}` // конечное название файла
          updateImages.push({
            size: `${images.value[index].w}x${images.value[index].h}`,
            name: filePath
          }) // сохраняем названия файлов
          let { error: uploadError } = supabase.storage
            .from(`orders/photo/${numberOrder.value}/${images.value[index].w}x${images.value[index].h}`) // оптравляем в storage по этому пути
            .upload(filePath, file) // название файла, сам файл
          if (uploadError) {
            console.log(uploadError)
            throw uploadError
          }
        })

        /*
        Тут отправляем в таблицу orders_photo всю информацию о том, кто заказывает и что
         */
        const updates = {
          owner: user && user.id || 'Не зарегистрирован',
          images: updateImages,
          order_id: numberOrder.value,
        }

        let { error } = await supabase.from("orders_photo").upsert(updates)
        loading.value = false
        orderModal.value = true

        images.value = []
        files.value = []
      } catch (error) {
        console.log(error.message)
      } finally {
        loading.value = false
      }
    }
    watch(files.value, () => {
      calcImages()
    })

    return {
      loading, images, openImage,
      openImageModal, price, files,
      numberOrder, orderModal, authModal,
      cropImage, cropImageModal,
      notStandardSize,
      user,
      selectImages, deleteImage, selectOpenImage,
      selectCropImage,readyCropImage,closeCropModal,
      selectSize, orderImages,
    }
  }
}
</script>

<style scoped lang="scss">
.photo {
  .container {
  }
  .preview-image-wrap {
    padding: 10px;
    display: grid;
    grid-template-columns: 1fr 1fr 1fr;
    grid-column-gap: 10px;
    grid-row-gap: 1em;
    @media (max-width: 400px) {
      grid-template-columns: 1fr 1fr;
    }
    .preview-image-container {
      position: relative;
      .preview-image {
        min-height: 13rem;
      }
      .image-delete,.image-crop {
        position: absolute;
        top: 10px;
        right: 10px;
        background: url("../../assets/images/icons/delete.png") no-repeat;
        background-size: 75%;
        background-position: center;
        background-color: #2a2a2a;
        width: 30px;
        height: 30px;
        opacity: .7;
        border-radius: 50%;
        border: 1px solid white;
        cursor: pointer;
        &:hover {
          opacity: 1;
        }
      }
      .image-crop {
        right: 45px;
        background: url("../../assets/images/icons/crop.png") no-repeat;
        background-size: 75%;
        background-position: center;
        background-color: #1a1a1a;
      }
    }
  }
}
</style>
